
module Biobase.ExtSS where

import Data.ByteString.Char8 as BS



-- | Extended secondary structures as used by RNAwolf. We have a sequence in
-- 5'->3' order. Then an extended structure string with ".()<>X" as pairing
-- symbols. Finally we have detailed pairing information which encodes
-- Leontis-Westhof notation. In addition, comments starting with "#" are
-- possible.

data ExtSS = ExtSS
  { sequence  :: !ByteString
  , structure :: !ByteString
  , detailed  :: ![(Int,Int,ByteString)]
  , comments  :: ![ByteString]
  } deriving (Read,Show)
